import java.util.*;

public class bookkeeping_bill {

	static class LazySegmentTree {
		int n, t[], d[], h;
		public LazySegmentTree(int N) {
			t = new int[(n = N) << 1];
			d = new int[N];
			h = 32 - Integer.numberOfLeadingZeros(N);
		}
		void apply(int p, int value) {
			t[p] += value;
			if (p < n) d[p] += value;
		}
		void build(int p) {
			for (; p > 1; p >>= 1, t[p] = Math.max(t[p<<1], t[p<<1|1]) + d[p]);
		}
		void push(int p) {
			for (int s = h; s > 0; --s) {
				int i = p >> s;
				if (d[i] != 0) {
					apply(i<<1, d[i]);
					apply(i<<1|1, d[i]);
					d[i] = 0;
				}
			}
		}
		void update(int l, int r, int value) {
			l += n;
			r += n;
			int l0 = l, r0 = r;
			for (; l < r; l >>= 1, r >>= 1) {
				if ((l&1)!=0) apply(l++, value);
				if ((r&1)!=0) apply(--r, value);
			}
			build(l0);
			build(r0-1);
		}
		int query(int l, int r) {
			push(l+n);
			push(r+n-1);
			int res = Integer.MIN_VALUE;
			for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
				if ((l&1)!=0) res = Math.max(res, t[l++]);
				if ((r&1)!=0) res = Math.max(res, t[--r]);
			}
			return res;
		}
	}
	
	static class Pt implements Comparable<Pt>{
		int letter;
		int y, x;
		public Pt(int letter, int r, int c) {
			this.letter = letter;
			this.y = r;
			this.x = c;
		}
		@Override
		public int compareTo(Pt g) {
			if (y != g.y) return y - g.y;
			if (x != g.x) return x - g.x;
			return letter - g.letter;
		}
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int w = in.nextInt();
		int h = in.nextInt();
		int a = in.nextInt();
		int b = in.nextInt();
		List<Pt> points = new ArrayList<>();
		for (int i = 0; i < h; ++i) {
			String s = in.next();
			for (int j = 0; j < w; ++j) {
				points.add(new Pt(s.charAt(j) - 'a', i, j));
			}
		}
		Collections.sort(points);
		
		ArrayDeque<Pt> window = new ArrayDeque<>();
		
		LazySegmentTree[] segTrees = new LazySegmentTree[26];
		for (int i = 0; i < 26; ++i) segTrees[i] = new LazySegmentTree(200000);
		
		int[] overallMax = new int[26];
		
		for (Pt p : points) {
			while (!window.isEmpty() && (window.peekFirst().y < p.y-b+1)) {
				Pt rem = window.pollFirst();
				segTrees[rem.letter].update(rem.x, rem.x+a, -1);
			}
			
			window.addLast(p);
			segTrees[p.letter].update(p.x, p.x+a, 1);
			overallMax[p.letter] = Math.max(overallMax[p.letter], segTrees[p.letter].query(0, 200000));
		}
		
		for (int i = 0; i < 26; ++i) {
			System.out.println(overallMax[i]);
		}
	}

}
