import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.StringTokenizer;

public class bookkeeping_portillo
{
	public static void main(String[] args) throws IOException
	{
		FastScanner in = new FastScanner();
		int w = in.nextInt();
		int h = in.nextInt();
		int a = in.nextInt();
		int b = in.nextInt();
		
		char data[][] = new char[h][];
		for(int i = 0; i < h; i++)
			data[i] = in.next().toCharArray();
		
		int cums[][][] = new int[26][][];
		for(int k = 0; k < 26; k++)
		{
			cums[k] = new int[h][w];
			
			for(int i = 0; i < h; i++)
				for(int j = 0; j < w; j++)
					if(data[i][j]-'a' == k)
						cums[k][i][j] = 1;
			
			cums[k] = cumulate(cums[k]);
		}
		
		int ans[] = new int[26];
		int ansX[] = new int[26];
		int ansY[] = new int[26];
		for(int k = 0; k < 26; k++)
		{
			for(int i = 0; i+b-1 < h; i++)
			{
				for(int j = 0; j+a-1 < w; j++)
				{
					int cur = sum(cums[k], i, j, i+b-1, j+a-1);
					if(cur > ans[k])
					{
						ans[k] = cur;
						ansX[k] = j;
						ansY[k] = i;
					}
					else if(ans[k] == cur)
					{
						if(i < ansY[k])
						{
							ans[k] = cur;
							ansX[k] = j;
							ansY[k] = i;
						}
						else if(i == ansY[k] && j < ansX[k])
						{
							ans[k] = cur;
							ansX[k] = j;
							ansY[k] = i;
						}
					}
				}
			}
		}
		
		for(int i = 0; i < 26; i++)
			System.out.println(ans[i]);
	}

	private static int[][] cumulate(int[][] d)
	{
		int ret[][] = new int[d.length+1][d[0].length+1];
		
		for(int i = 0; i < d.length; i++)
			for(int j = 0; j < d[0].length; j++)
				ret[i+1][j+1] = ret[i+1][j] + ret[i][j+1] + d[i][j] - ret[i][j];
		
		return ret;
	}
	
	private static int sum(int d[][], int r1, int c1, int r2, int c2)
	{
		return d[r1][c1] + d[r2+1][c2+1] - d[r1][c2+1] - d[r2+1][c1];
	}

	public static class FastScanner
	{
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(String s)
		{
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public FastScanner()
		{
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		String nextToken()
		{
			while (st == null || !st.hasMoreElements())
			{
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt()
		{
			return Integer.parseInt(nextToken());
		}

		long nextLong()
		{
			return Long.parseLong(nextToken());
		}

		double nextDouble()
		{
			return Double.parseDouble(nextToken());
		}
		
		String next()
		{
			return nextToken();
		}
		
		public boolean hasNext()
		{
			if(st != null && st.hasMoreElements())
				return true;
			
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				// TODO Auto-generated catch block
				return false;
			}
			
			if(st == null) return false;
			return true;
		}
	}
}
