/*
	extraset-n3.cpp
	Solution to "Extraset"
	SIUCF CompProg Camp 2018, Contest 2

	This code runs in O(n^3/6) but in fact
	is faster than the O(kn^2) solution.

	solution by Charles B.

	9 July 2018
*/
#include <bits/stdc++.h>

typedef long long ll;

static inline void setio(void);

int main(void) {
	setio();
	ll k,n; std::cin >> k >> n;

	std::vector<std::vector<ll>> vec(n, std::vector<ll>(k));
	for (auto& r : vec) for (auto& e : r) std::cin >> e;

	std::vector<std::vector<ll>> adj(n, std::vector<ll>(n));

	for (ll i = 0; i < n; ++i) {
		for (ll j = i+1; j < n; ++j) {
			for (ll x = 0; x < k; ++x) {
				adj[j][i] |= adj[i][j] |= (vec[i][x] == vec[j][x]) << x;
			}
		}
	}

	ll tot = 0;

	for (ll i = 0; i < n; ++i)
		for (ll j = i+1; j < n; ++j)
			for (ll x = j+1; x < n; ++x) {
				tot += adj[i][j] == adj[i][x] && adj[i][j] == adj[j][x];
				if (adj[i][j] == adj[i][x] && adj[i][j] == adj[j][x]) {
					std::cerr << "found set for " << i << " " << j << std::endl;
				}
			}

	std::cout << tot << "\n";

	std::cerr << std::setprecision(6) << static_cast<double>(clock())/CLOCKS_PER_SEC << "\n";

	return 0;
}

static inline void setio(void) {
	std::ios::sync_with_stdio(false);std::cin.tie(nullptr);
	std::cout.precision(10); std::cout << std::fixed;
}
