// Arup Guha
// 4/4/2018
// Solution to 2018 COP 4516 Final Team Exam Problem E: Extra Set
// Adapted for 2018 SI@UCF Contest #2 (7/9/2018)

import java.util.*;

public class extraset {

	public static int k;
	public static int n;
	public static long[] cList;
	public static HashSet<Long> cSet;

	public static void main(String[] args) {

		Scanner stdin = new Scanner(System.in);

		// Get basic parameters.
		k = stdin.nextInt();
		n = stdin.nextInt();

		// Store cards here.
		cList = new long[n];
		cSet = new HashSet<Long>();
		for (int i=0; i<n; i++) {

			// Read in attributes for one card - store as bitmask.
			for (int j=0; j<k; j++) {
				int val = stdin.nextInt();
				cList[i] = (cList[i] << 2) + val;
			}

			// Store in our hash set also.
			cSet.add(cList[i]);
		}

		long res = 0;

		// Loop through all pairs of cards.
		for (int i=0; i<n; i++) {
			for (int j=i+1; j<n; j++) {

				// Get what would be the third matching card.
				long match = getMatch(cList[i],cList[j]);

				// Add 1 if this is also in our set of cards.
				if (cSet.contains(match))
					res++;
			}
		}

		// We counted each set three times for (1,2), (1,3) and (2,3).
		System.out.println(res/3);
	}

	public static long getMatch(long c1, long c2) {

		long res = 0;

		// i is the lsb of our card mask
		for (int i=0; i<2*k; i+=2) {

			// Extract attributes.
			long x = (c1 >> i) & 3L;
			long y = (c2 >> i) & 3L;

			// Same.
			if (x == y) res = res | (x << i);

			// Different. (Since sum of masks is 3, subtracting from 3 extracts the last item.)
			else		res = res | ((3-x-y) << i);
		}

		return res;
	}
}