import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class holes_portillo
{
	static int BUCKET = 316;
	public static void main(String[] args) throws IOException
	{
		FastScanner in = new FastScanner();
		int n = in.nextInt();
		int m = in.nextInt();
		int data[] = new int[n];
		int to[] = new int[n];
		int jumps[] = new int[n];
		for(int i = 0; i < n; i++)
			data[i] = in.nextInt();
		
		for(int i = n-1; i >= 0; i--)
		{
			int next = i+data[i];
			if(i/BUCKET == next/BUCKET && next < n)
			{
				to[i] = to[next];
				jumps[i] = jumps[next]+1;
			}
			else
			{
				to[i] = next;
				jumps[i] = 1;
			}
		}
		
		for(int k = 0; k < m; k++)
		{
			int cmd = in.nextInt();
			
			if(cmd == 0)//update
			{
				int idx = in.nextInt()-1;
				int changeTo = in.nextInt();
				data[idx] = changeTo;
				
				int start = idx/BUCKET*BUCKET;
				int end = Math.min(start+BUCKET, n);
				
				for(int i = end-1; i >= start; i--)
				{
					int next = i+data[i];
					if(i/BUCKET == next/BUCKET && next < n)
					{
						to[i] = to[next];
						jumps[i] = jumps[next]+1;
					}
					else
					{
						to[i] = next;
						jumps[i] = 1;
					}
				}
			}
			else
			{
				int pos = in.nextInt()-1;
				int cnt = 0;
				
				while(to[pos] < n)
				{
					cnt += jumps[pos];
					pos = to[pos];
				}
				
				while(pos+data[pos] < n)
				{
					cnt++;
					pos += data[pos];
				}
				
				System.out.println((pos+1) + " " + (cnt+1));
			}
		}
	}
 
	public static class FastScanner
	{
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(String s)
		{
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public FastScanner()
		{
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		String nextToken()
		{
			while (st == null || !st.hasMoreElements())
			{
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt()
		{
			return Integer.parseInt(nextToken());
		}

		long nextLong()
		{
			return Long.parseLong(nextToken());
		}

		double nextDouble()
		{
			return Double.parseDouble(nextToken());
		}
		
		String next()
		{
			return nextToken();
		}
		
		public boolean hasNext()
		{
			if(st != null && st.hasMoreElements())
				return true;
			
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				// TODO Auto-generated catch block
				return false;
			}
			
			if(st == null) return false;
			return true;
		}
	}
}
