import static java.lang.Integer.bitCount;
import static java.lang.Integer.max;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class moreicecream_bill {
	
	static class Scanner {
		BufferedReader br;
		StringTokenizer st;
		Scanner(InputStream in) {
			br = new BufferedReader(new InputStreamReader(in));
			eat("");
		}
		void eat(String s) {
			st = new StringTokenizer(s);
		}
		String nextLine() {
			try {
				return br.readLine();
			} catch (Exception e) {
				throw null;
			}
		}
		boolean hasNext() {
			while (!st.hasMoreTokens()) {
				String s = nextLine();
				if (s == null) return false;
				eat(s);
			}
			return true;
		}
		String next() {
			hasNext();
			return st.nextToken();
		}
		int nextInt() {
			return Integer.parseInt(next());
		}
		long nextLong() {
			return Long.parseLong(next());
		}
		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	private static final class SegmentTree {
		int n, t[];
		private SegmentTree(int N) {
			t = new int[(n = N) << 1];
		}
		private static int combine(final int a, final int b) {
			int bca = bitCount(a);
			int bcb = bitCount(b);
			if (bca > bcb) return a;
			if (bca < bcb) return b;
			return max(a, b);
		}
		private void build() {
			for (int i = n; --i > 0 ;) t[i] = combine(t[i<<1], t[i<<1|1]);
		}
		private void modify(int p, final int value) {
			for (t[p += n] = value; p > 1; p >>= 1) t[p>>1] = combine(t[p], t[p^1]);
		}
		private int query(int l, int r) { // [l,r)
			int res = 0;
			for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
				if ((l&1)!=0) res = combine(res, t[l++]);
				if ((r&1)!=0) res = combine(res, t[--r]);
			}
			return res;
		}
	}
	
	
	public static void main(String[] args) {
		// stack trick
		new Thread(null, () -> asdf(args), "", 1<<28).start(); } public static void asdf(String[] args) {
		
		Scanner in = new Scanner(System.in);
		PrintWriter out = new PrintWriter(System.out);
		int N = in.nextInt();
		int Q = in.nextInt();
		k = new int[N];
		for (int i = 0; i < N; ++i) k[i] = in.nextInt();
		children = new List[N];
		for (int i = 0; i < N; ++i) children[i] = new ArrayList<>();
		for (int i = 1; i < N; ++i) children[in.nextInt() - 1].add(i);
		open = new int[N];
		close = new int[N];
		segTree = new SegmentTree(N);
		idx = 0;
		dfs(0);
		segTree.build();
		
		for (int i = 0; i < Q; ++i) {
			switch (in.nextInt()) {
			case 1: {
				int r = in.nextInt() - 1;
				out.println(segTree.query(open[r], close[r]));
				break;
			}
			case 2: {
				int r = in.nextInt() - 1;
				int c = in.nextInt();
				segTree.modify(open[r], c);
				break;
			}
			}
		}
		out.close();
	}
	
	private static int open[], close[], k[], idx;
	private static SegmentTree segTree;
	private static List<Integer>[] children;
	private static void dfs(final int u) {
		segTree.t[idx+segTree.n] = k[u];
		open[u] = idx++;
		for (int v : children[u]) {
			dfs(v);
		}
		close[u] = idx;
	}

}
