// Arup Guha
// 7/10/2018
// Alternate Solution to 2018 SI@UCF Contest #2 Problem: Phil and Plinko

import java.util.*;

public class plinko_arup {
	
	final public static int[] DX = {-1,0,1};
	final public static String PATHS = "\\|/";
	
	public static int r;
	public static int c;
	public static int maxChange;
	public static char[][] grid;
	public static int[][] pts;
	public static int[][][] dp;
	
	public static void main(String[] args) {
		
		// Get basic info.
		Scanner stdin = new Scanner(System.in);
		r = stdin.nextInt();
		c = stdin.nextInt();
		maxChange = stdin.nextInt();
		
		// Set up and read grids.
		grid = new char[r][];
		pts = new int[r][c];
		for (int i=0; i<r; i++)
			grid[i] = stdin.next().toCharArray();
		for (int i=0; i<r; i++)
			for (int j=0; j<c; j++)
				pts[i][j] = stdin.nextInt();
				
		int res = 0;
				
		// Store best results for row i, col j with k fixes in dp[i][j][k].
		dp = new int[r][c][maxChange+1];
		
		// We can start anywhere, so set these scores...
		for (int i=0; i<r; i++)
			for (int j=0; j<c; j++)
				dp[i][j][0] = grid[i][j] == '#' ? 0 : pts[i][j];
			
		// First go down row by row.
		for (int i=1; i<r; i++) {
			
			// Fine to do this forward.
			for (int j=0; j<c; j++) {
				
				// Skip these.
				if (grid[i][j] == '#') continue;
				
				// It's okay if we do this one forward also.
				for (int k=0; k<=maxChange; k++) {
					
					// Where we could build from.
					for (int dir=0; dir<DX.length; dir++) {
						
						// Can't build from out of bounds.
						if (j+DX[dir] < 0 || j+DX[dir] >= c) continue;
						
						// Old value of k.
						int oldk = map(grid[i-1][j+DX[dir]]) == dir ? k : k-1;
						
						// Avoid array out of bounds.
						if (oldk < 0) continue;
						
						// Update if this is better.
						dp[i][j][k] = Math.max(dp[i][j][k], pts[i][j] + dp[i-1][j+DX[dir]][oldk]);
						res = Math.max(res, dp[i][j][k]);
					}
				} // end k
			} // end j
		} // end i
		
		// Ta da!!!
		System.out.println(res);
	}
	
	// Returns index of c in PATHS string.
	public static int map(char c) {
		for (int i=0; i<PATHS.length(); i++)
			if (c == PATHS.charAt(i))
				return i;
		return -1;
	}
}