//package test;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.nio.charset.StandardCharsets;
import java.util.InputMismatchException;

public class test {

	static class Solver {

		String combine(String s, String t) {
			String w = t + "#" + s;

			int pref[] = new int[w.length()];
			pref[0] = 0;
			int j = 0;
			for (int i = 1; i < w.length(); ++i) {
				while (j > 0 && w.charAt(i) != w.charAt(j))
					j = pref[j - 1];
				if (w.charAt(i) == w.charAt(j))
					++j;
				pref[i] = j;
			}

			for (int i = t.length() + 1; i < w.length(); ++i)
				if (pref[i] == t.length())
					return s;

			int x = pref[w.length() - 1];
			StringBuilder ans = new StringBuilder(s);
			for (int i = x; i < t.length(); ++i)
				ans.append(t.charAt(i));
			return ans.toString();
		}

		int ans = 987654321;

		void Solve(String s1, String s2, String s3) {
			String res = s1;
			res = combine(res, s2);
			res = combine(res, s3);
			ans = Math.min(ans, res.length());
		}

		void solve(FastScanner s, PrintWriter out) {
			String a = s.next(), b = s.next(), c = s.next();
			Solve(a, b, c);
			Solve(a, c, b);
			Solve(b, a, c);
			Solve(b, c, a);
			Solve(c, a, b);
			Solve(c, b, a);
			out.println(ans);
		}

	}

	public static void main(String[] args) {

		FastScanner s = new FastScanner(System.in);
		PrintWriter out = new PrintWriter(System.out);

		Solver solver = new Solver();
		solver.solve(s, out);

		out.close();

	}

	static class FastScanner {
		private InputStream stream;
		private byte[] buf = new byte[1024];
		private int curChar;
		private int numChars;

		public FastScanner(InputStream stream) {
			this.stream = stream;
		}

		public FastScanner(String s) throws FileNotFoundException {
			this(new FileInputStream(new File(s)));
		}

		public FastScanner(String s, boolean v) {
			this.stream = new ByteArrayInputStream(s.getBytes(StandardCharsets.UTF_8));
		}

		int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		boolean isEndline(int c) {
			return c == '\n' || c == '\r' || c == -1;
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}

		public double nextDouble() {
			return Double.parseDouble(next());
		}

		public String next() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		public String nextLine() {
			int c = read();
			while (isEndline(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isEndline(c));
			return res.toString();
		}

		// Jacob Garbage

		public int[] nextIntArray(int N) {
			int[] ret = new int[N];
			for (int i = 0; i < N; i++)
				ret[i] = this.nextInt();
			return ret;
		}

		public long[] nextLongArray(int N) {
			long[] ret = new long[N];
			for (int i = 0; i < N; i++)
				ret[i] = this.nextLong();
			return ret;
		}

		public int[][] next2DIntArray(int N, int M) {
			int[][] ret = new int[N][];
			for (int i = 0; i < N; i++)
				ret[i] = this.nextIntArray(M);
			return ret;
		}

		public double[] nextDoubleArray(int N) {
			double[] ret = new double[N];
			for (int i = 0; i < N; i++)
				ret[i] = this.nextDouble();
			return ret;
		}

		public double[][] next2DDoubleArray(int N, int M) {
			double[][] ret = new double[N][];
			for (int i = 0; i < N; i++)
				ret[i] = this.nextDoubleArray(M);
			return ret;
		}

	}

}
