// Arup Guha
// 7/9/2018
// Alternate Solution to 2018 SI@UCF Contest #2 Problem Tower Counting

import java.util.*;

public class tower_arup {

	public static void main(String[] args) {
		
		Scanner stdin = new Scanner(System.in);
		long disks = stdin.nextLong();
		long pegs = stdin.nextLong();
		long mod = stdin.nextLong();
		
		// Ta da! Each disk can be placed on any of the pegs number of pegs, then multiply!
		System.out.println(modExp(pegs, disks, mod));
	}
	
	// Returns b raised to the power e mod mod. 
	public static long modExp(long b, long e, long mod) {
		
		// Base case - need to account for mod == 1.
		if (e == 0) return 1%mod;
		
		// Here is where we save time.
		if (e%2 == 0) {
			long tmp = modExp(b, e/2, mod);
			return (tmp*tmp)%mod;
		}
		
		// Regular recursive case.
		return (b*modExp(b, e-1, mod))%mod;
	}
}
